#!/bin/bash

PTEXLIVE_VER=`ls  ../ptexlive-*.tar.gz|sed "s/.*ptexlive-//;s/.tar.gz//"`
echo "*** ptexlive: $PTEXLIVE_VER"
pushd ../ptexlive-$PTEXLIVE_VER
. common.sh
popd
necessity_command autoreconf --version
WEBDIR=$TMP_PREFIX/texlive-20091011-source/texk/web2c/

## patch pTeX
QTRIP_VER=`ls ../ptex-qtrip-*.tar.gz 2>/dev/null |sed "s/.*ptex-qtrip-//;s/.tar.gz//"`
if [ "x$QTRIP_VER" = "x" ]; then
  echo "*** ptex-qtrip: NOT FOUND (this is not an error)"
else
  echo "*** ptex-qtrip: $QTRIP_VER"
  # the content of ptex-src-3.1.11-box.patch is already in 
  # ptex-base.ch.0308.diff in ptex-qtrip.
  cat ../ptexlive-$PTEXLIVE_VER/archive/ptex-src-3.1.11-box.patch | \
    (cd $WEBDIR/ptexdir; patch -p0 -R ) || exit 1
  tarx ../ptex-qtrip-$QTRIP_VER.tar.gz $TMP_PREFIX
  (cd $TMP_PREFIX/ptex-qtrip;
  for x in ptex-base.ch.*.diff; do
    echo "[patching]   $x"
    cat $x | (cd $WEBDIR/ptexdir; patch -p0)
  done
  )
fi

## various patches
echo "[patching]   support m4-1.4.14"
cat tl09-m4_1.4.14.patch | (cd $WEBDIR/../..; $PATCH -p0) || exit 1
echo "[patching]   epup-tl09.diff"
cat epup-tl09.diff | (cd $WEBDIR/../..; $PATCH -p0) || exit 1

## patch for e-pTeX
echo "[copying]    ptexdir -> eptexdir"
rm -rf $WEBDIR/eptexdir
cp -r $WEBDIR/ptexdir $WEBDIR/eptexdir || exit 1
echo "[copying]    fam256.ch"
cp fam256.ch  $WEBDIR/eptexdir/ || exit 1
echo "[moving]     ptex.defines -> eptex.defines"
mv $WEBDIR/eptexdir/ptex.defines $WEBDIR/eptexdir/eptex.defines || exit 1
echo "[moving]     ptex-base.ch -> eptex-base.ch"
mv $WEBDIR/eptexdir/ptex-base.ch $WEBDIR/eptexdir/eptex-base.ch || exit 1
echo "[patching]   eptex-base-tl09-3.1.11.diff "
cat eptex-base-tl09-3.1.11.diff | (cd $WEBDIR/eptexdir; $PATCH -p0) || exit 1
echo "[patching]   ep-tl09.diff"
cat ep-tl09.diff | (cd $WEBDIR/../..; $PATCH -p0) || exit 1

## regenerate configure etc.
echo "[rewriting]  autoreconf in $WEBDIR"
(cd $WEBDIR ; autoreconf --verbose)
echo "[rewriting]  configure"
cat $WEBDIR/configure | sed "s/fiif/fi\nif/;s/esac#/esac\n#/" > $WEBDIR/configure.new
mv $WEBDIR/configure.new $WEBDIR/configure || exit 1
chmod +x $WEBDIR/configure

## compile
(cd ../ptexlive-$PTEXLIVE_VER;
$MAKE stage3 || exit 1
$MAKE stage4 || exit 1
)

## copying distfiles
echo "[copying]    eptex.src"
mkdir -p $TEXMF/ptex/plain/base
cp eptex.src $TEXMF/ptex/plain/base/ || exit 1
echo "[copying]    language.def"
mkdir -p $TEXMF/ptex/generic/config
cp language.def $TEXMF/ptex/generic/config/ || exit 1

(cd ../ptexlive-$PTEXLIVE_VER;
$MAKE macro otf
)

echo "================"
echo "  please execute './6babel.sh; cd ../ptexlive-$PTEXLIVE_VER; make fonty test'"
